﻿-- **********************************************************************
-- GnomTEC Gnomcorder Comm
-- Version: 7.2.0.13
-- Author: GnomTEC
-- Copyright 2011-2016 by GnomTEC
-- http://www.gnomtec.de/
-- **********************************************************************
-- load localization first.
local L = LibStub("AceLocale-3.0"):GetLocale("GnomTEC_Gnomcorder_Comm")

local CONST_BATTERY_CONSUMPTION_SEND_NORMAL	= 50
local CONST_BATTERY_CONSUMPTION_SEND_RANGE	= 100
local CONST_BATTERY_CONSUMPTION_RECEIVE	= 10

local volumeValuesChannel1 = {
	["Volume0"] = {
		text = "|cffff8000Kommunikationskanal ausgeschaltet",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_VOLUMEBUTTON:SetText("Kommunikationskanal ausgeschaltet");
			GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume = "Volume0";
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:Disable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RANGE:Disable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RELAIS:Disable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SEND:Disable();
		end,
	},
	["Volume1"] = {
		text = "Lautsprecher im Silent Mode",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_VOLUMEBUTTON:SetText("Lautsprecher im Silent Mode");
			GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume = "Volume1";
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RANGE:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RELAIS:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SEND:Enable();
		end,
	},
	["Volume2"] = {
		text = "Funksprüche aus dem Lautsprecher teilweise hörbar",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_VOLUMEBUTTON:SetText("Funksprüche aus dem Lautsprecher teilweise hörbar");
			GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume = "Volume2";
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RANGE:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RELAIS:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SEND:Enable();
		end,
	},
	["Volume3"] = {
		text = "Funksprüche aus dem Lautsprecher für Alle hörbar",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_VOLUMEBUTTON:SetText("Funksprüche aus dem Lautsprecher für Alle hörbar");
			GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume = "Volume3";
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RANGE:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RELAIS:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SEND:Enable();
		end,
	},
}

local volumeValuesChannel2 = {
	["Volume0"] = {
		text = "|cffff8000Kommunikationskanal ausgeschaltet",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:SetText("Kommunikationskanal ausgeschaltet");
			GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume = "Volume0";
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Disable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Disable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Disable();
		end,
	},
	["Volume1"] = {
		text = "Lautsprecher im Silent Mode",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:SetText("Lautsprecher im Silent Mode");
			GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume = "Volume1";
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Enable();
		end,
	},
	["Volume2"] = {
		text = "Funksprüche aus dem Lautsprecher teilweise hörbar",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:SetText("Funksprüche aus dem Lautsprecher teilweise hörbar");
			GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume = "Volume2";
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Enable();
		end,
	},
	["Volume3"] = {
		text = "Funksprüche aus dem Lautsprecher für Alle hörbar",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:SetText("Funksprüche aus dem Lautsprecher für Alle hörbar");
			GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume = "Volume3";
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Enable();
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Enable();
		end,
	},
}

local speakValuesChannel1 = {
	["Speak0"] = {
		text = "Unbemerkt in das Mikrofon sprechen",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:SetText("Unbemerkt in das Mikrofon sprechen");
			GnomTEC_Gnomcorder_Comm_Options["Channel1"].Speak = "Speak0";
		end,
	},
	["Speak1"] = {
		text = "Leise in das mikrofon sprechen",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:SetText("Leise in das mikrofon sprechen");
			GnomTEC_Gnomcorder_Comm_Options["Channel1"].Speak = "Speak1";
		end,
	},
	["Speak2"] = {
		text = "Laut in das Mikrofon sprechen",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:SetText("Laut in das Mikrofon sprechen");
			GnomTEC_Gnomcorder_Comm_Options["Channel1"].Speak = "Speak2";
		end,
	},
}

local speakValuesChannel2 = {
	["Speak0"] = {
		text = "Unbemerkt in das Mikrofon sprechen",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:SetText("Unbemerkt in das Mikrofon sprechen");
			GnomTEC_Gnomcorder_Comm_Options["Channel2"].Speak = "Speak0";
		end,
	},
	["Speak1"] = {
		text = "Leise in das mikrofon sprechen",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:SetText("Leise in das mikrofon sprechen");
			GnomTEC_Gnomcorder_Comm_Options["Channel2"].Speak = "Speak1";
		end,
	},
	["Speak2"] = {
		text = "Laut in das Mikrofon sprechen",
		notCheckable = 1,
		func = function ()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:SetText("Laut in das Mikrofon sprechen");
			GnomTEC_Gnomcorder_Comm_Options["Channel2"].Speak = "Speak2";
		end,
	},
}

GnomTEC_Gnomcorder_Comm_Options = {
	["Channel1"] =
	{
		Volume = "Volume0",
		Speak = "Speak0",
		Range = false,
		Relais = false,
	},
	["Channel2"] =
	{
		ChannelName = "Funkkanal",
		Volume = "Volume0",
		Speak = "Speak0",
		Range = false,
		Relais = false,
	},
}

local optionsMain = {
	name = "GnomTEC Gnomcorder Comm",
	type = "group",
	args = {
		descriptionTitle = {
			order = 1,
			type = "description",
			name = "Kommunikationsmodul für GnomTEC Gnomcorder.\n\n",
		},
		descriptionAbout = {
			name = "About",
			type = "group",
			guiInline = true,
			order = 2,
			args = {
				descriptionVersion = {
				order = 1,
				type = "description",			
				name = "|cffffd700".."Version"..": ".._G["GREEN_FONT_COLOR_CODE"]..GetAddOnMetadata("GnomTEC_Gnomcorder_Comm", "Version"),
				},
				descriptionAuthor = {
					order = 2,
					type = "description",
					name = "|cffffd700".."Autor"..": ".."|cffff8c00".."GnomTEC",
				},
				descriptionEmail = {
					order = 3,
					type = "description",
					name = "|cffffd700".."Email"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."info@gnomtec.de",
				},
				descriptionWebsite = {
					order = 4,
					type = "description",
					name = "|cffffd700".."Website"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."http://www.gnomtec.de/",
				},
				descriptionLicense = {
					order = 5,
					type = "description",
					name = "|cffffd700".."Copyright"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."(c)2011-2017 by GnomTEC",
				},
			}
		},
		descriptionLogo = {
			order = 5,
			type = "description",
			name = "",
			image = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\GnomTEC-Logo",
			imageCoords = {0.0,1.0,0.0,1.0},
			imageWidth = 512,
			imageHeight = 128,
		},
	}
}
			
GnomTEC_Gnomcorder_Comm = LibStub("AceAddon-3.0"):NewAddon("GnomTEC_Gnomcorder_Comm", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")

LibStub("AceConfig-3.0"):RegisterOptionsTable("GnomTEC Gnomcorder Comm Main", optionsMain)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GnomTEC Gnomcorder Comm Main", "GnomTEC Gnomcorder Comm");

local function emptynil( x ) return x ~= "" and x or nil end

local function GnomTEC_Gnomcorder_Comm_ChatFilterOfficer(self, event, msg, ...)
	if (GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume ~= "Volume0") then
		msg = string.gsub(msg,"^!%d ","")
		return false, msg, ...
	else
		return true
	end
end

local function GnomTEC_Gnomcorder_Comm_ChatFilterChannel(self, event, message, sender, language, channelString, target, flags, unknown, channelNumber, channelName, ...)
	channelName = channelName or ""
	if (strupper(GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName) == strupper(channelName)) then
		if (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume ~= "Volume0") then
			message = string.gsub(message,"^!%d ","")
			return false, message, sender, language, channelString, target, flags, unknown, channelNumber, channelName, ...
		else
			return true
		end
	else
		return false, message, sender, language, channelString, target, flags, unknown, channelNumber, channelName, ...
	end
end

function GnomTEC_Gnomcorder_Comm:OnInitialize()
 	-- Code that you want to run when the addon is first loaded goes here.
  
  	GnomTEC_Gnomcorder_Comm:Print("Willkommen bei GnomTEC_Gnomcorder_Comm")
  	  	
end

function GnomTEC_Gnomcorder_Comm:OnEnable()
    -- Called when the addon is enabled

	GnomTEC_Gnomcorder_Comm:Print("GnomTEC_Gnomcorder_Comm Enabled")

	-- Initialize options which are propably not valid because they are new added in new versions of addon
	if (not GnomTEC_Gnomcorder_Comm_Options["Channel1"]) then
		GnomTEC_Gnomcorder_Comm_Options["Channel1"] =	{ Volume = "Volume0", Speak = "Speak0", Range = false, Relais = false}
	end
	if (not GnomTEC_Gnomcorder_Comm_Options["Channel2"]) then
		GnomTEC_Gnomcorder_Comm_Options["Channel2"] =	{ Volume = "Volume0", Speak = "Speak0", Range = false, Relais = false}
	end
	
	if (not GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName) then
		GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName = "Funkkanal"
	end

	-- set local parameters
	GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_VOLUMEBUTTON:SetText(volumeValuesChannel1[GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume].text); 
	GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:SetText(speakValuesChannel1[GnomTEC_Gnomcorder_Comm_Options["Channel1"].Speak].text); 
	GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RANGE:SetChecked(GnomTEC_Gnomcorder_Comm_Options["Channel1"].Range)
	GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RELAIS:SetChecked(GnomTEC_Gnomcorder_Comm_Options["Channel1"].Relais)
	
	if (GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume ~= "Volume0") then
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:Enable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RANGE:Enable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RELAIS:Disable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SEND:Enable()
	else
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKBUTTON:Disable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RANGE:Disable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RELAIS:Disable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SEND:Disable()	
	end
	
	GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:SetText(volumeValuesChannel2[GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume].text); 
	GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:SetText(speakValuesChannel2[GnomTEC_Gnomcorder_Comm_Options["Channel2"].Speak].text); 
	GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:SetChecked(GnomTEC_Gnomcorder_Comm_Options["Channel2"].Range)
	GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:SetChecked(GnomTEC_Gnomcorder_Comm_Options["Channel2"].Relais)
	
	local channelID, channelName = GetChannelName(GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName)
	if (channelID > 0) then
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_CHANNELNAMEBUTTON:SetText("/"..channelID.." "..channelName); 
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:Enable()
		if (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume ~= "Volume0") then
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Enable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Enable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Enable()
		else	
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Disable()	
		end	
	else
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_CHANNELNAMEBUTTON:SetText("/? "..GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName); 
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:Disable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Disable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Disable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable()
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Disable()	
	end

	-- Register events and hook on functions
	GnomTEC_Gnomcorder_Comm:RegisterEvent("CHAT_MSG_OFFICER");
	GnomTEC_Gnomcorder_Comm:RegisterEvent("CHAT_MSG_CHANNEL");
	GnomTEC_Gnomcorder_Comm:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE");
	GnomTEC_Gnomcorder_Comm:RawHook("SendChatMessage","ProcessCommmunication",true)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", GnomTEC_Gnomcorder_Comm_ChatFilterOfficer)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", GnomTEC_Gnomcorder_Comm_ChatFilterChannel)

	-- Add module to GnomTEC Gnomcorder
	GnomTEC_Gnomcorder:AddButton("Comm", "Schalter", "Bedienelemente", GNOMTEC_GNOMCORDER_COMM_FRAME, "Interface\\ICONS\\INV_Gizmo_GoblinBoomBox_01", "Interface\\ICONS\\INV_Gizmo_GoblinBoomBox_01", false, nil)
end

function GnomTEC_Gnomcorder_Comm:OnDisable()
    -- Called when the addon is disabled
    ChatFrame_RemoveMessageEventFilter("CHAT_MSG_OFFICER", GnomTEC_Gnomcorder_Comm_ChatFilterOfficer)
    ChatFrame_RemoveMessageEventFilter("CHAT_MSG_CHANNEL", GnomTEC_Gnomcorder_Comm_ChatFilterChannel)
    GnomTEC_Gnomcorder_Comm:UnregisterAllEvents();
end

function GnomTEC_Gnomcorder_Comm:CHAT_MSG_OFFICER(eventName, message, sender)
	if (sender ~= UnitName("player")) then
		-- sicherheitshalber nochmal filtern falls Filter nicht greift
		message = string.gsub(message,"^!%d ","")
		if (GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume == "Volume1") then
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_RECEIVE)
			PlaySound("PVPFLAGTAKENHORDEMONO");
			-- eventuell blinkende LEDs emoten (einstellbar machen)
		elseif (GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume == "Volume2") then
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_RECEIVE)
			PlaySound("PVPFLAGTAKENHORDEMONO");
			local output = "";
			local i=3;
			local buchstabe
			for buchstabe in string.gmatch(message, "[%w%p%s]") do
				if (0 == (i % 3)) then
					output = output..buchstabe;
				else
					output = output..".";
				end
				i = i + 1;
			end
			SendChatMessage("Gnomcorder: '"..output.."'","EMOTE");		
		elseif (GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume == "Volume3") then
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_RECEIVE)
			PlaySound("PVPFLAGTAKENHORDEMONO");
			SendChatMessage("Gnomcorder: '"..message.."'","EMOTE");
		else
			-- nichts tun wenn ausgeschaltet
		end
	end
end

function GnomTEC_Gnomcorder_Comm:CHAT_MSG_CHANNEL_NOTICE(eventName, message, arg2, arg3, arg4, arg5, arg6, arg7, channelNumber, channelName)
	if (strupper(GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName) == strupper(channelName)) then
		if message == "YOU_JOINED" then
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:Enable()
			if (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume ~= "Volume0") then
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Enable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Enable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Enable()
			else	
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Disable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Disable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Disable()	
			end
		elseif message == "YOU_LEFT" then
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Disable()	
  		end
	end
end

function GnomTEC_Gnomcorder_Comm:CHAT_MSG_CHANNEL(eventName, message, sender, language, channelString, target, flags, unknown, channelNumber, channelName)
	if (sender ~= UnitName("player")) and (strupper(GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName) == strupper(channelName)) then
				-- sicherheitshalber nochmal filtern falls Filter nicht greift
		message = string.gsub(message,"^!%d ","")
		if (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume == "Volume1") then
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_RECEIVE)
			PlaySound("PVPFLAGTAKENHORDEMONO");
			-- eventuell blinkende LEDs emoten (einstellbar machen)
		elseif (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume == "Volume2") then
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_RECEIVE)
			PlaySound("PVPFLAGTAKENHORDEMONO");
			local output = "";
			local i=3;
			local buchstabe
			for buchstabe in string.gmatch(message, "[%w%p%s]") do
				if (0 == (i % 3)) then
					output = output..buchstabe;
				else
					output = output..".";
				end
				i = i + 1;
			end
			SendChatMessage("Gnomcorder: '"..output.."'","EMOTE");		
		elseif (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume == "Volume3") then
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_RECEIVE)
			PlaySound("PVPFLAGTAKENHORDEMONO");
			SendChatMessage("Gnomcorder: '"..message.."'","EMOTE");
		else
			-- nichts tun wenn ausgeschaltet
		end
	end
end

function GnomTEC_Gnomcorder_Comm:ProcessCommmunication(msg, chatType, language, channel)	
	-- process communication channel 1 (/officer)
	if (chatType == "OFFICER") then
		if (GnomTEC_Gnomcorder_Comm_Options["Channel1"].Volume ~= "Volume0") then
			if (GnomTEC_Gnomcorder_Comm_Options["Channel1"].Speak == "Speak1") then 
				SendChatMessage("spricht leise in den Gnomcorder.","EMOTE");
			elseif (GnomTEC_Gnomcorder_Comm_Options["Channel1"].Speak == "Speak2") then
				SendChatMessage("spricht in den Gnomcorder.","EMOTE");
				SendChatMessage(msg,"SAY");
			end
			if (GnomTEC_Gnomcorder_Comm_Options["Channel1"].Range) then
				GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_SEND_RANGE)
				msg = "!1 "..msg
			else
				GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_SEND_NORMAL)
				msg = "!0 "..msg
			end			
			self.hooks.SendChatMessage(msg,chatType,language, channel)
		else
			-- communication is disabled --> don't send anything
			GnomTEC_Gnomcorder_Comm:Print("Kommunikationskanal 1 ist nicht eingeschaltet!")
		end
	elseif (chatType == "CHANNEL") then
		local channelID, channelName = GetChannelName(channel)
		channelName = channelName or ""
		if (strupper(GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName) == strupper(channelName)) then
			if (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume ~= "Volume0") then
				if (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Speak == "Speak1") then 
					SendChatMessage("spricht leise in den Gnomcorder.","EMOTE");
				elseif (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Speak == "Speak2") then
					SendChatMessage("spricht in den Gnomcorder.","EMOTE");
					SendChatMessage(msg,"SAY");
				end
				if (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Range) then
					GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_SEND_RANGE)
					msg = "!1 "..msg
				else
					GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_SEND_NORMAL)
					msg = "!0 "..msg
				end			
				self.hooks.SendChatMessage(msg,chatType,language, channel)
			else
				-- communication is disabled --> don't send anything
				GnomTEC_Gnomcorder_Comm:Print("Kommunikationskanal 2 ist nicht eingeschaltet!")
			end		
		else
			self.hooks.SendChatMessage(msg,chatType,language, channel)
		end
	else
		self.hooks.SendChatMessage(msg,chatType,language, channel)
	end
end

--
-- functions for channel 1
--

function GnomTEC_Gnomcorder_Comm_Channel1_InitializeVolumeDropDown(level)
	local key, value
	
	for key,value in pairs(volumeValuesChannel1) do	
		UIDropDownMenu_AddButton(value)
	end

end


function GnomTEC_Gnomcorder_Comm:Channel1_VolumeDropdown_OnLoad(self)
	UIDropDownMenu_Initialize(self,  GnomTEC_Gnomcorder_Comm_Channel1_InitializeVolumeDropDown, "MENU")
end

function GnomTEC_Gnomcorder_Comm:Channel1_VolumeButton_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_VOLUMEDROPDOWN, self:GetName(), 0, 0)
end


function GnomTEC_Gnomcorder_Comm_Channel1_InitializeSpeakDropDown(level)
	local key, value
	
	for key,value in pairs(speakValuesChannel1) do	
		UIDropDownMenu_AddButton(value)
	end

end

function GnomTEC_Gnomcorder_Comm:Channel1_SpeakDropdown_OnLoad(self)
	UIDropDownMenu_Initialize(self,  GnomTEC_Gnomcorder_Comm_Channel1_InitializeSpeakDropDown, "MENU")
end

function GnomTEC_Gnomcorder_Comm:Channel1_SpeakButton_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SPEAKDROPDOWN, self:GetName(), 0, 0)
end


function GnomTEC_Gnomcorder_Comm:Channel1_Range_OnClick()
	GnomTEC_Gnomcorder_Comm_Options["Channel1"].Range = GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RANGE:GetChecked()
end

function GnomTEC_Gnomcorder_Comm:Channel1_Relais_OnClick()
	GnomTEC_Gnomcorder_Comm_Options["Channel1"].Relais = GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_RELAIS:GetChecked()
end



function GnomTEC_Gnomcorder_Comm:Channel1_Send()
	if (GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SEND:GetText() ~= "") then
		SendChatMessage(GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SEND:GetText(),"OFFICER");
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL1_SEND:SetText("")
	end
end



--
-- functions for channel 2
--

function GnomTEC_Gnomcorder_Comm_Channel2_InitializeChannelNameDropDown(level)
	local entry = {};
	
	entry.notChackable = 1
	function entry.func (self, arg1)
		GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName = arg1;
		local channelID, channelName = GetChannelName(arg1)
		if (channelID > 0) then
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_CHANNELNAMEBUTTON:SetText("/"..channelID.." "..channelName); 
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:Enable()
			if (GnomTEC_Gnomcorder_Comm_Options["Channel2"].Volume ~= "Volume0") then
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Enable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Enable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Enable()
			else	
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Disable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Disable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable()
				GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Disable()	
			end	
		else
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_CHANNELNAMEBUTTON:SetText("/? "..arg1); 
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEBUTTON:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKBUTTON:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:Disable()
			GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:Disable()			
		end
	end
		
	local name, header, collapsed, channelNumber, active, count, category, voiceEnabled, voiceActive;
	local channelCount = GetNumDisplayChannels();
	local i;
	for i=1, channelCount, 1 do
		name, header, collapsed, channelNumber, count, active, category, voiceEnabled, voiceActive = GetChannelDisplayInfo(i);

		if (category == "CHANNEL_CATEGORY_CUSTOM") then
			if (strupper(GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName) == strupper(name)) then
				entry.text = "|cff00ff00/"..(channelNumber or "?").." "..name;
			else
				entry.text = "/"..(channelNumber or "?").." "..name;
			end
			entry.arg1 = name;
			UIDropDownMenu_AddButton(entry);
		end
	end
	
	local channelID, channelName;
	channelID, channelName= GetChannelName(GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName)
	if (channelID == 0) then
			entry.text = "|cffff0000/?".." "..GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName;
			entry.arg1 = GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName;
			UIDropDownMenu_AddButton(entry);
	end
	entry.text = "|cffff8000/? ".."---NONE---";
	entry.arg1 = "---NONE---";
	UIDropDownMenu_AddButton(entry);
	

end

function GnomTEC_Gnomcorder_Comm:Channel2_ChannelNameDropdown_OnLoad(self)
	UIDropDownMenu_Initialize(self,  GnomTEC_Gnomcorder_Comm_Channel2_InitializeChannelNameDropDown, "MENU")
end

function GnomTEC_Gnomcorder_Comm:Channel2_ChannelNameButton_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_CHANNELNAMEDROPDOWN, self:GetName(), 0, 0)
end


function GnomTEC_Gnomcorder_Comm_Channel2_InitializeVolumeDropDown(level)
	local key, value
	
	for key,value in pairs(volumeValuesChannel2) do	
		UIDropDownMenu_AddButton(value)
	end

end


function GnomTEC_Gnomcorder_Comm:Channel2_VolumeDropdown_OnLoad(self)
	UIDropDownMenu_Initialize(self,  GnomTEC_Gnomcorder_Comm_Channel2_InitializeVolumeDropDown, "MENU")
end

function GnomTEC_Gnomcorder_Comm:Channel2_VolumeButton_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_VOLUMEDROPDOWN, self:GetName(), 0, 0)
end


function GnomTEC_Gnomcorder_Comm_Channel2_InitializeSpeakDropDown(level)
	local key, value
	
	for key,value in pairs(speakValuesChannel2) do	
		UIDropDownMenu_AddButton(value)
	end

end

function GnomTEC_Gnomcorder_Comm:Channel2_SpeakDropdown_OnLoad(self)
	UIDropDownMenu_Initialize(self,  GnomTEC_Gnomcorder_Comm_Channel2_InitializeSpeakDropDown, "MENU")
end

function GnomTEC_Gnomcorder_Comm:Channel2_SpeakButton_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SPEAKDROPDOWN, self:GetName(), 0, 0)
end


function GnomTEC_Gnomcorder_Comm:Channel2_Range_OnClick()
	GnomTEC_Gnomcorder_Comm_Options["Channel2"].Range = GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RANGE:GetChecked()
end

function GnomTEC_Gnomcorder_Comm:Channel2_Relais_OnClick()
	GnomTEC_Gnomcorder_Comm_Options["Channel2"].Relais = GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_RELAIS:GetChecked()
end



function GnomTEC_Gnomcorder_Comm:Channel2_Send()
	if (GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:GetText() ~= "") then
		local channelID, channelName = GetChannelName(GnomTEC_Gnomcorder_Comm_Options["Channel2"].ChannelName)
		if (channelID > 0) then
			SendChatMessage(GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:GetText(),"CHANNEL", nil, channelID);
		else
			GnomTEC_Gnomcorder_Comm:Print("Kommunikationskanal 2 ist nicht verfügbar!")
		end
		GNOMTEC_GNOMCORDER_COMM_FRAME_CHANNEL2_SEND:SetText("")
	end
end